DisplayOverviewHudItemEvent = {};
DisplayOverviewHudItemEvent_mt = Class(DisplayOverviewHudItemEvent, Event);
InitEventClass(DisplayOverviewHudItemEvent, "DisplayOverviewHudItemEvent");

function DisplayOverviewHudItemEvent:emptyNew()
	local self = Event:new(DisplayOverviewHudItemEvent_mt);
	self.className="DisplayOverviewHudItemEvent";
	return self;
end;

function DisplayOverviewHudItemEvent:new(itemTable)
	local self = DisplayOverviewHudItemEvent:emptyNew();
	self.doFillUtilItems = itemTable;
	return self;
end;

function DisplayOverviewHudItemEvent:writeStream(streamId, connection)
	if self.doFillUtilItems ~= nil then		
		local numStrings = Utils.getNoNil(#self.doFillUtilItems, 0);
		streamWriteInt32(streamId, numStrings);
		for a=1,#self.doFillUtilItems do					
			if self.doFillUtilItems[a] ~= nil then streamWriteString(streamId, tostring(self.doFillUtilItems[a]));end;			
		end;
	end;		
end;

function DisplayOverviewHudItemEvent:readStream(streamId, connection)
	function setItemToServer(streamString)
		local streamStringSplit = StringUtil.splitString("-DO-", streamString);
		if streamStringSplit ~= nil and #streamStringSplit > 0 then
			local itemClassName = tostring(streamStringSplit[1]);
			local itemNodeId = tonumber(streamStringSplit[2]);
			local itemX = tonumber(streamStringSplit[3]);
			local itemY = tonumber(streamStringSplit[4]);
			local itemZ = tonumber(streamStringSplit[5]);
			local itemFillLevel = tonumber(streamStringSplit[6]);
			local itemFillType = tonumber(streamStringSplit[7]);
			local itemFillCapacity = tonumber(streamStringSplit[8]);
			local itemI3dFilename = tostring(streamStringSplit[9]);
			local itemOwnerFarmId = tonumber(streamStringSplit[10]);
			doFillUtilItemsToServer[itemNodeId] = {};
			doFillUtilItemsToServer[itemNodeId].className = itemClassName;
			doFillUtilItemsToServer[itemNodeId].nodeId = itemNodeId;
			doFillUtilItemsToServer[itemNodeId].x = itemX;
			doFillUtilItemsToServer[itemNodeId].y = itemY;
			doFillUtilItemsToServer[itemNodeId].z = itemZ;
			doFillUtilItemsToServer[itemNodeId].fillLevel = itemFillLevel;
			doFillUtilItemsToServer[itemNodeId].fillType = itemFillType;
			doFillUtilItemsToServer[itemNodeId].capacity = itemFillCapacity;
			doFillUtilItemsToServer[itemNodeId].i3dFilename = itemI3dFilename;
			doFillUtilItemsToServer[itemNodeId].ownerFarmId = itemOwnerFarmId;
		end;		 
	end;
	if g_currentMission.missionDynamicInfo.isMultiplayer and g_server == nil then		
		local numString = streamReadInt32(streamId);
		if numString ~= nil and numString > 0 then
			doFillUtilItemsToServer = {};
			for a=1, numString do
				local streamString = streamReadString(streamId);				
				setItemToServer(streamString);
			end;
		end;	
	end;
end;

function DisplayOverviewHudItemEvent.sendEvent(itemTable)
	if g_server == nil then			
		--g_client:getServerConnection():sendEvent(DisplayOverviewHudItemEvent:new(), nil, nil, nil);			
	elseif g_currentMission.missionDynamicInfo.isMultiplayer and g_server ~= nil and g_server ~= false then	
		g_server:broadcastEvent(DisplayOverviewHudItemEvent:new(itemTable), nil, nil, nil);			
	end;
end;